GDAL-VECTOR-RENAME-LAYER(1)

NAME
gdal-vector-rename-layer - Rename layer(s) of a vector dataset

Added in version 3.13.

SYNOPSIS

    Usage: gdal vector rename-layer [OPTIONS] <INPUT> <OUTPUT>
    Rename layer(s) of a vector dataset.
    Positional arguments:
      -i, --input <INPUT>                                  Input vector datasets [required] [not available in pipelines]
      -o, --output <OUTPUT>                                Output vector dataset [required] [not available in pipelines]
    Common Options:
      -h, --help                                           Display help message and exit
      --json-usage                                         Display usage as JSON document and exit
      --config <KEY>=<VALUE>                               Configuration option [may be repeated]
      -q, --quiet                                          Quiet mode (no progress bar or warning message) [not available in pipelines]
    Options:
      -f, --of, --format, --output-format <OUTPUT-FORMAT>  Output format ("GDALG" allowed) [not available in pipelines]
      --co, --creation-option <KEY>=<VALUE>                Creation option [may be repeated] [not available in pipelines]
      --lco, --layer-creation-option <KEY>=<VALUE>         Layer creation option [may be repeated] [not available in pipelines]
      --overwrite                                          Whether overwriting existing output dataset is allowed [not available in pipelines]
      --update                                             Whether to open existing dataset in update mode [not available in pipelines]
      --overwrite-layer                                    Whether overwriting existing output layer is allowed [not available in pipelines]
      --append                                             Whether appending to existing layer is allowed [not available in pipelines]
                                                           Mutually exclusive with --upsert
      --output-layer <OUTPUT-LAYER>                        Output layer name
      --skip-errors                                        Skip errors when writing features [not available in pipelines]
      -l, --input-layer <INPUT-LAYER>                      Input layer name
      --ascii                                              Force names to ASCII character
      --lower-case                                         Force names to lower case (only on ASCII characters)
      --filename-compatible                                Force names to be usable as filenames
      --reserved-characters <RESERVED-CHARACTERS>          Reserved character(s) to be removed
      --replacement-character <REPLACEMENT-CHARACTER>      Replacement character when ASCII conversion not possible
      --max-length <MAX-LENGTH>                            Maximum length of layer names
    Advanced Options:
      --if, --input-format <INPUT-FORMAT>                  Input formats [may be repeated] [not available in pipelines]
      --oo, --open-option <KEY>=<VALUE>                    Open options [may be repeated] [not available in pipelines]
      --output-oo, --output-open-option <KEY>=<VALUE>      Output open options [may be repeated] [not available in pipelines]
      --upsert                                             Upsert features (implies 'append') [not available in pipelines]
                                                           Mutually exclusive with --append

DESCRIPTION

gdal vector rename-layer can be used to rename layer(s).

It has two modes:

•   one where the user renames a single layer to a given name with --output-layer, combined with --input-layer if there are more than one layer.

•   another one where the user may force various operations to alter the layer names:

•   Force characters to ASCII: --ascii

•   Force characters to lower case: --lower-case

•   Force compatibility with file names: --filename-compatible

•   Remove or replace characters from a list of reserved characters: --reserved-characters

•   Truncate to a maximum number of characters: --max-length

    For --filename-compatible and --reserved-characters, incompatible characters are removed, unless --replacement-character is specified.

    In this mode, uniqueness of layer names is also attempted by appending _{N} where NN is a sequence number. Uniqueness may not be achieved if --max-length is set to a too low value.

    This subcommand is also available as a potential step of gdal vector pipeline

PROGRAM SPECIFIC OPTIONS

--input-layer <INPUT-LAYER>
    Name of input layer. To be used together with --output-layer

--output-layer <OUTPUT-LAYER>
    Name of output layer. If there are several input layers, --output-layer must also be specified.

--ascii
    Force characters to ASCII. Currently only accented characters characters in Latin 1 Supplement and Latin Extended A character set have a sensible ASCII replacement. Other non-ASCII characters will be removed or replaced by the replacement character specified with --replacement-character

--lower-case
    Force characters to lower-case. Currently only ASCII upper case characters are replaced. This option is applied after --ascii, if the later is specified.

--filename-compatible
    Force layer names to be compatible of file names for Linux, Windows or MacOS, independently from the operating system on which this command is run.

--reserved-characters <RESERVED-CHARACTERS>
    Reserved character(s) to remove or replace with the replacement character specified with --replacement-character

--replacement-character <REPLACEMENT-CHARACTER>
    Replacement character when ASCII conversion is not possible or to substitute to reserved characters.

--max-length <MAX-LENGTH>
    Truncate to a maximum number of characters

STANDARD OPTIONS

--append
    Whether appending features to existing layer(s) is allowed. This also creates the output dataset if it does not exist yet.

--co, --creation-option <NAME>=<VALUE>
    Many formats have one or more optional dataset creation options that can be used to control particulars about the file created. For instance, the GeoPackage driver supports creation options to control the version.

    May be repeated.

    The dataset creation options available vary by format driver, and some simple formats have no creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Vector drivers format specific documentation for legal creation options for each format.

    Note that dataset creation options are different from layer creation options.

--if, --input-format <format>
    Format/driver name to be attempted to open the input file(s). It is generally not necessary to specify it, but it can be used to skip automatic driver detection, when it fails to select the appropriate driver. This option can be repeated several times to specify several candidate drivers. Note that it does not force those drivers to open the dataset. In particular, some drivers have requirements on file extensions.

    May be repeated.

--lco, --layer-creation-option <NAME>=<VALUE>
    Many formats have one or more optional layer creation options that can be used to control particulars about the layer created. For instance, the GeoPackage driver supports layer creation options to control the feature identifier or geometry column name, setting the identifier or description, etc.

    May be repeated.

    The layer creation options available vary by format driver, and some simple formats have no layer creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Vector drivers format specific documentation for legal creation options for each format.

    Note that layer creation options are different from dataset creation options.

--oo, --open-option <NAME>=<VALUE>
    Dataset open option (format specific).

    May be repeated.

-f, --of, --format, --output-format <OUTPUT-FORMAT>
    Which output vector format to use. Allowed values may be given by gdal --formats | grep vector | grep rw | sort

--output-layer <NAME>
    Specifies the name of the layer to which features will be written. If not specified, output layer names will be the same as input layer names.

--output-open-option, --output-oo <NAME>=<VALUE>
    Added in version 3.12.

    Dataset open option for output dataset (format specific).

    May be repeated.

--overwrite
    Allow program to overwrite existing target file or dataset. Otherwise, by default, gdal errors out if the target file or dataset already exists.

--overwrite-layer
    Whether overwriting the existing output vector layer is allowed.

--skip-errors
    Added in version 3.12.

    Whether failures to write feature(s) should be ignored. Note that this option sets the size of the transaction unit to one feature at a time, which may cause severe slowdown when inserting into databases.

--update
    Whether to open an existing output dataset in update mode.

--upsert
    Added in version 3.12.

    Variant of --append where the OGRLayer::UpsertFeature() operation is used to insert or update features instead of appending with OGRLayer::CreateFeature().

    This is currently implemented only in a few drivers: GPKG -- GeoPackage vector, Elasticsearch: Geographically Encoded Objects for Elasticsearch and MongoDBv3 (drivers that implement upsert expose the GDAL_DCAP_UPSERT capability).

    The upsert operation uses the FID of the input feature, when it is set (and the FID column name is not the empty string), as the key to update existing features. It is crucial to make sure that the FID in the source and target layers are consistent.

    For the GPKG driver, it is also possible to upsert features whose FID is unset or non-significant (the --unset-fid option of gdal vector edit can be used to ignore the FID from the source feature), when there is a UNIQUE column that is not the integer primary key.

RETURN STATUS CODE

The program returns status code 0 in case of success, and non-zero in case of error (non-blocking errors emitted as warnings are considered as a successful execution).

EXAMPLES

  Example 1: Rename a given layer to a user selected name.

    $ gdal vector rename-layer input.gpkg output.gpkg --input-layer "name with space" --output-layer "without_space"

  Example 2: Force layer names to ASCII, lower case, without space character and to be filename compatible.

    $ gdal vector rename-layer input.gpkg output_shp_directory --output-format "ESRI Shapefile" --ascii --lower-case --filename-compatible --reserved-characters " "

AUTHOR
Even Rouault <even.rouault@spatialys.com>

COPYRIGHT
1998-2026